#include "stdafx.h"
#include "cvapp.h"
 
// A global variable
ImageProcessor *proc = 0;
SequenceProcessor *procseq = 0;
//iteratore

template <class PEL>
class IplImageIterator {
  int i, i0,j;
  PEL* data;
  PEL* pix;
  int step;
  int nl, nc;
  int nch;
 public:
  /* costruttore */
  IplImageIterator(IplImage* image, 
  	int x=0, int y=0, int dx= 0, int dy=0) : 
       i(x), j(y), i0(0) {
    data= reinterpret_cast<PEL*>(image->imageData); 
    step= image->widthStep / sizeof(PEL);
    nl= image->height;
    if ((y+dy)>0 && (y+dy)<nl) nl= y+dy;
    if (y<0) j=0;
    data+= step*j;
    nc= image->width ;
    if ((x+dx)>0 && (x+dx)<nc) nc= x+dx;
    nc*= image->nChannels;
    if (x>0) i0= x*image->nChannels;
    i= i0;
    nch= image->nChannels;
    pix= new PEL[nch];}
  /* ha il successivo? */
  bool operator!() const { return j < nl; }
  /* successivo */
  IplImageIterator& operator++() {i++; 
    if (i >= nc) { i=i0; j++; data+= step; }
    return *this;}
  IplImageIterator& operator+=(int s) {i+=s; 
    if (i >= nc) { i=i0; j++; data+= step; }
    return *this;}
  /* accesso al pixel */
  PEL& operator*() { return data[i]; }
  const PEL operator*() const { return data[i]; }
  const PEL neighbor(int dx, int dy) const 
    { return *(data+dy*step+i+dx); }
  PEL* operator&() const { return data+i; }
  /* coordinate del pixel corrente*/
  int column() const { return i/nch; }
  int line() const { return j; }
};




// the functions that processes the image
void process(void* img) {              
 
  IplImage* image = reinterpret_cast<IplImage*>(img);
  cvErode( image, image, 0, 2 );
 
}

void process2(void* img) {
/*//funozione senza iteratore  
  IplImage* image = reinterpret_cast<IplImage*>(img);
  int nl= image->height;
  int nc= image->width * image->nChannels;
  int step= image->widthStep; // a causa dell'allineamento
  // poich imageData  un signed char*
  unsigned char *data= reinterpret_cast<unsigned char *>(image->imageData);
  for (int i=0; i<nl; i++) {
    for (int j=0; j<nc; j+= image->nChannels) {
        // 3 canali per pixel
          if (data[j+1] > data[j] && data[j+1] > data[j+2]) {
             data[j]= 0xFF;   // 255
             data[j+1]= 0xFF;
             data[j+2]= 0xFF;
        }
     }
      data+= step;  // linea successiva
   }
*/
	//finzione con iteratore
 IplImage* image = reinterpret_cast<IplImage*>(img);
  IplImageIterator<unsigned char> it(image);
  unsigned char* pixel;
  while (!it) {
     pixel= &it;
     if (pixel[1]>pixel[0] && pixel[1]>pixel[2]) {
          pixel[0]= 0xFF;   
         pixel[1]= 0xFF;   //per i tre canali 255 cio bianco
         pixel[2]= 0xFF;   
     }
     it+= 3;
  }
}

void process3(void* img) {
  IplImage* image = reinterpret_cast<IplImage*>(img);
  IplImage* tmp= cvCloneImage(image); 
  IplImageIterator<unsigned char> 
      src(tmp,1,1,tmp->width-2,tmp->height-2);
  IplImageIterator<unsigned char> 
      res(image,1,1,image->width-2,image->height-2);
  while (!src) {
	  *res= abs(*src - src.neighbor(-1,-1) +
                  src.neighbor(-1,0) - 
                  src.neighbor(0,-1));
	  ++src;
	  ++res;
  }
   cvReleaseImage(&tmp);
}
void ImageProcessor::execute() {
 
  process(img);
}

void ImageProcessor::execute2() {
 
  process2(img);
}

void ImageProcessor::execute3() {
 
  process3(img);
}
IPin *GetPin(IBaseFilter *pFilter, PIN_DIRECTION PinDir)
{
    BOOL       bFound = FALSE;
    IEnumPins  *pEnum;
    IPin       *pPin;

    pFilter->EnumPins(&pEnum);
    while(pEnum->Next(1, &pPin, 0) == S_OK)
    {
        PIN_DIRECTION PinDirThis;
        pPin->QueryDirection(&PinDirThis);
        if (bFound = (PinDir == PinDirThis))
            break;
        pPin->Release();
    }
    pEnum->Release();
    return (bFound ? pPin : 0);  
}
